/* Autogenerated with Kurento Idl */

/*
 * (C) Copyright 2013-2015 Kurento (https://kurento.openvidu.io/)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var kurentoClient = require('kurento-client');



/**
 * .
 *
 * @typedef elements/complexTypes.CertificateKeyType
 *
 * @type {(RSA|ECDSA)}
 */

/**
 * Checker for {@link module:elements/complexTypes.CertificateKeyType}
 *
 * @memberof module:elements/complexTypes
 *
 * @param {external:String} key
 * @param {module:elements/complexTypes.CertificateKeyType} value
 */
function checkCertificateKeyType(key, value)
{
  if(typeof value != 'string')
    throw SyntaxError(key+' param should be a String, not '+typeof value);

  if(!value.match('RSA|ECDSA'))
    throw SyntaxError(key+' param is not one of [RSA|ECDSA] ('+value+')');
};


module.exports = checkCertificateKeyType;
